(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
GraphicsTools::usage="GraphicsTools is a simple package (no context created) containing the following functions:   
    RoundedBox, CubicSmoothShift, PolygonBelowLine, OffsetTextLabel, LabeledArrow, LabeledSegment, DoubleArrow, AddArrow, SimpleArrowheads, PerpendicularLabel, AngleLabel, Polar, Spherical, Angle, CoordinateAxes, AxesTicks, Projection3D, CoordinateProjection3D, ShadedLine, LinePolygonMap, LinePolygonMappingRules, DrawParameterizedCurve, EuclideanMap2D, SimpleVectorArray, MinPolynomial, ColorShade, GrayShade, LinesFromPlot, LinetoAxis, LinetoBothAxes, LabeledLinetoAxis, SecantLine, TangentLine, PlotAndShade, MakeList, FadeOut";


(* ::Input::Initialization:: *)
LabelingTools::usage="LabelingTools is a simple package (no context created) containing the following functions: OffsetTextLabel, LabeledArrow, LabeledSegment, DoubleArrow and SimpleArrowheads.";


(* ::Input::Initialization:: *)
OffsetTextLabel::usage="OffsetTextLabel is an operator-form function that acts on a Line or Arrow object. It has the syntax OffsetTextLabel[txt_,other___,opts][Arrow[...]]. It produces {Arrow[...],Text[txt,coordinates,other,opts for Text]}. The coordinates are offset from the segment containing the endpoints of Arrow (or Line) and rotated with the endpoints. It passes options through to Text and has its own options: LabelPosition, AbsoluteOffset and CoordinateOffset";SimpleArrowheads::usage="SimpleArrowheads[w] gives the Arrowheads directive for a simple line arrowhead.";
LabeledArrow::usage="LabeledArrow[tail:{0,0},tip,label,opts] gives an Arrow from tail to tip with a string, 'label', offset from the center.";
LabeledSegment::usage="LabeledSegment[tail:{0,0},tip,label,opts] gives a segment from tail to tip with a string, 'label', offset from the center.";
DoubleArrow::usage="DoubleArrow[r1,r2,text,opts] draws a double arrow between r1 and r2 with text at center. The text is at the center of the gap. TextGap option must be adjusted to give room for the Text. TextGap->0 and TextOffset place the text away from the center. TextGap greater than one gives inward pointing arrows; this is useful for small gaps.";


(* ::Input::Initialization:: *)
WidthRatio::usage="WidthRatio is an option for SimpleArrowheads.";
FilledArrow::usage="FilledArrow is an option for SimpleArrowheads.";
ArrowDirectives::usage="ArrowDirectives is an option for SimpleArrowheads.";
ArrowOffset::usage="ArrowOffset is an option for SimpleArrowheads.";
LabelPosition::usage="LabelPosition is an option for OffsetTextLabel. Its values interpolate between the starting position of Arrow (or Line) with value 0 and with value 1 at the endpoint. It has a default value of 1/2, the midpoint. LabelPosition be outside of the 0 to 1 range.";
AbsoluteOffset::usage="AbsoluteOffset is an option for OffsetTextLabel. Its coodinates {x,y} are measured in printer points and are relative to LabelPosition. x is in the direction from the starting point to the endpoint and y is perpendicular to that. If only one coordinate value is given then that is y, the perpendicular part, and the x value is zero.";
CoordinateOffset::usage="CoordinateOffset is an option for OffsetTextLabel. Its coodinates {x,y} are measured relative to the graphics coordinates and are relative to LabelPosition. x is in the direction from the starting point to the endpoint and y is perpendicular to that. If only one coordinate value is given then that is y, the perpendicular part, and the x value is zero.";AbsoluteTextOffset::usage="AbsoluteTextOffset is an option for LabeledArrow, LabeledSegment and DoubleArrow.";
ArrowDirectives::usage="ArrowDirectives is an option for LabeledArrow and DoubleArrow.";
TextAlignment::usage="TextAlignment is an option for LabeledArrow, LabeledSegment and DoubleArrow.";
TextGap::usage="TextGap is an option for DoubleArrow.";
LineDirectives::usage="LineDirectives is an option for LabeledSegment.";
TextOffset::usage="TextOffset is an option for several functions.";


(* ::Input::Initialization:: *)
Options[OffsetTextLabel]={LabelPosition->1/2,AbsoluteOffset->12,CoordinateOffset->0};Options[SimpleArrowheads]={WidthRatio->1,FilledArrow->False,ArrowDirectives->{},ArrowOffset->0};
Options[LabeledArrow]={TextOffset->1,AbsoluteTextOffset->True,ArrowDirectives->{},TextPosition->.5,TextAlignment->{0,0}};
Options[LabeledSegment]={TextOffset->1,AbsoluteTextOffset->True,Global`LineDirectives->{},TextPosition->.5,TextAlignment->{0,0}};
Options[DoubleArrow]={TextPosition->0.5,TextGap->0.1,TextOffset->0,ArrowDirectives->{}};


(* ::Input::Initialization:: *)
OffsetTextLabel[txt_,other___,opts:OptionsPattern[{OffsetTextLabel,Text}]][arrowOrLine_[expr_List,more___]]/;MatchQ[arrowOrLine,Arrow|Line]:=
With[{
toList=If[NumericQ[#],{0,#},#]&,
r0=expr[[1]],r1=expr[[-1]]},
With[{
optsText=Sequence@@FilterRules[{opts}, Options[Text]],AOS=toList[OptionValue[AbsoluteOffset]],
COS=toList[OptionValue[CoordinateOffset]],
\[Lambda]=OptionValue[LabelPosition],
u=Normalize[r1-r0],
v=Normalize[{-#[[2]],#[[1]]}&[r1-r0]]},{Text[txt,Offset[AOS . {u,v},\[Lambda] r1+(1-\[Lambda])r0+COS . {u,v}],other,optsText],arrowOrLine[expr,more]}]]


(* ::Input::Initialization:: *)
SimpleArrowheads[w_,OptionsPattern[]]:=Arrowheads[{{Automatic,Automatic,Graphics[(AOS|->With[{pts=w/2 {{-AOS-1,OptionValue[WidthRatio]/2},{-AOS,0},{-AOS-1,-OptionValue[WidthRatio]/2}}},
Join[If[Head[OptionValue[ArrowDirectives]]===List,OptionValue[ArrowDirectives],{OptionValue[ArrowDirectives]}],{If[
OptionValue[FilledArrow],Polygon[pts],
Line[pts]]}]])/@If[Head[OptionValue[ArrowOffset]]===List,OptionValue[ArrowOffset],{OptionValue[ArrowOffset]}]]}}]
SimpleArrowheads[]=SimpleArrowheads[1];


(* ::Input::Initialization:: *)
LabeledArrow[tail_List:{0,0},tip_List,str_,OptionsPattern[]]:=
With[{xBasis=(tip-tail)/Norm[tip-tail],yBasis={-(tip-tail)[[2]],(tip-tail)[[1]]}/Norm[tip-tail],OffsetCoords=If[NumericQ[OptionValue[TextOffset]],{0,OptionValue[TextOffset]},OptionValue[TextOffset]]},
Join[If[Head[OptionValue[ArrowDirectives]]===List,OptionValue[ArrowDirectives],{OptionValue[ArrowDirectives]}],{Text[str,
If[OptionValue[AbsoluteTextOffset],
Offset[15 (OffsetCoords[[1]] xBasis+OffsetCoords[[2]] yBasis),tail+OptionValue[TextPosition](tip-tail)],
0.15 (OffsetCoords[[1]] xBasis+OffsetCoords[[2]] yBasis)+tail+OptionValue[TextPosition](tip-tail)],OptionValue[TextAlignment]
],Arrow[{tail,tip}]}]]


(* ::Input::Initialization:: *)
LabeledSegment[tail_List:{0,0},tip_List,str_,OptionsPattern[]]:=
With[{xBasis=(tip-tail)/Norm[tip-tail],yBasis={-(tip-tail)[[2]],(tip-tail)[[1]]}/Norm[tip-tail],OffsetCoords=If[NumericQ[OptionValue[TextOffset]],{0,OptionValue[TextOffset]},OptionValue[TextOffset]]},
Join[If[Head[OptionValue[LineDirectives]]===List,OptionValue[LineDirectives],{OptionValue[LineDirectives]}],{Text[str,
If[OptionValue[AbsoluteTextOffset],
Offset[15 (OffsetCoords[[1]] xBasis+OffsetCoords[[2]] yBasis),tail+OptionValue[TextPosition](tip-tail)],
0.15 (OffsetCoords[[1]] xBasis+OffsetCoords[[2]] yBasis)+tail+OptionValue[TextPosition](tip-tail)],OptionValue[TextAlignment]
],Line[{tail,tip}]}]]


(* ::Input::Initialization:: *)
DoubleArrow[A_List,B_List,t_,OptionsPattern[]]:=
With[{C=A+(B-A) (OptionValue[TextPosition]-1/2 OptionValue[TextGap]),D=A+(B-A) (OptionValue[TextPosition] +1/2 OptionValue[TextGap]),
threeDQ=3==Length[A]==Length[B]},
Join[If[Head[OptionValue[ArrowDirectives]]===List,OptionValue[ArrowDirectives],{OptionValue[ArrowDirectives]}],{Arrow[{C,A}],Arrow[{D,B}],Text[t,A+(B-A) OptionValue[TextPosition]+If[threeDQ,{0,0,0},OptionValue[TextOffset] ({-#[[2]],#[[1]]}&)[B-A]]]}]]


(* ::Input::Initialization:: *)
CoordinateMapping::usage="CoordinateMapping is a simple package (no context created) containing the following functions: LinePolygonMap, LinePolygonMappingRules, and EuclideanMap2D.";


(* ::Input::Initialization:: *)
LinePolygonMap::usage="LinePolygonMap[f,expr] maps the coordinates in Line, Arrow, Polygon, Text and GraphicsComplex from x to f[x]. Acting on Rectangle it is converted to Polygon and then transformed. LinePolygonMap[f,expr] and expr/.LinePolygonMappingRules[f] are equivalent.";
LinePolygonMappingRules::usage="LinePolygonMappingRules[f] gives the rules to map the Line, Arrow, Polygon, Text and GraphicsComplex from x to f[x]. Acting on Rectangle it is converted to Polygon and then transformed. LinePolygonMap[f,expr] and expr/.LinePolygonMappingRules[f] are equivalent.";
EuclideanMap2D::usage="EuclideanMap2D[\[Theta],v:{0,0},expr] rotates all but text by \[Theta] and then translates by v.";


(* ::Input::Initialization:: *)
LinePolygonMappingRules[f_]:=
{Line[y_List]:>Line[f/@y],
Arrow[y_List]:>Arrow[f/@y],
Polygon[y_List]:>Polygon[f/@y],
Text[str_,x_,ext___]:>Text[str,f[x],ext],
Rectangle[{x1_,y1_},{x2_,y2_}]:>Polygon[f/@{{x1,y1},{x2,y1},{x2,y2},{x1,y2}}],
GraphicsComplex[y_List,unchanged___]:>GraphicsComplex[f/@y,unchanged]}
LinePolygonMap[f_,expr_]:=
expr/.LinePolygonMappingRules[f]


(* ::Input::Initialization:: *)
EuclideanMap2D[\[Theta]_,v_List:{0,0},expr_]:=
GeometricTransformation[expr,{RotationMatrix[\[Theta]],v}]/.Text[str_,more__]:>Text[Rotate[str,-\[Theta]],more]


(* ::Input::Initialization:: *)
Curves::usage="Curves is a simple package (no context created) containing the following functions: DrawParameterizedCurve, ShadedLine, CubicSmoothShift, PolygonBelowLine and RoundedBox.";


(* ::Input::Initialization:: *)
DrawParameterizedCurve::usage="DrawParameterizedCurve[expr,{\[Lambda],\[Lambda]0:0,\[Lambda]1},n:50] makes a Line[...] expression from expr.";
ShadedLine::usage="ShadedLine[{r1,r2,r3,...},h,opts] gives a line with a polygon of width h to its left.  The option PolygonDirectives allows for customization of the polygon.  The line may be customized with directives as usual. A negative h puts the polygon on the right.  ClosedLine->True completes the line to a loop.";


(* ::Input::Initialization:: *)
CubicSmoothShift::usage="CubicSmoothShift[{x1,y1,m1:0},{x2,y2,m2:0},n:50] gives a Line with a cubic with derivatives m1 and m2 at the endpoints.";
PolygonBelowLine::usage="PolygonBelowLine[y0:0,expr] replaces any Line in expr with a Polygon between it and y=y0";
RoundedBox::usage="RoundedBox[{x1,y1},{x2,y2},R,opts] creates an empty, Opacity[0], Rectangle with rounded corners of radius R and enlarged by R.  The border is by defalt a red dashed line.  The Option LineDirectives can change the form of the border.  The Opacity and color of the filling can be changed with the RectangleDirectives Option.";


(* ::Input::Initialization:: *)
LineDirectives::usage="LineDirectives is an option for RoundedBox and LabeledSegment.";


(* ::Input::Initialization:: *)
RectangleDirectives::usage="RectangleDirectives is an option for RoundedBox.";


(* ::Input::Initialization:: *)
Attributes[DrawParameterizedCurve]={HoldAll};
DrawParameterizedCurve[expr_,{\[Lambda]_,\[Lambda]0_:0,\[Lambda]1_},n_:50]:=Line[Function[\[Lambda],expr]/@Range[\[Lambda]0,\[Lambda]1,(\[Lambda]1-\[Lambda]0)/n]]


(* ::Input::Initialization:: *)
PolygonDirectives::usage="PolygonDirectives is an option for ShadedLine.";
ClosedLine::usage="ClosedLine is an option for ShadedLine.";


(* ::Input::Initialization:: *)
Options[ShadedLine]={PolygonDirectives->{},ClosedLine->False};


(* ::Input::Initialization:: *)
ShadedLine[rList_List,h_,opts:OptionsPattern[]]/;Length[rList]>1:=
If[OptionValue[ClosedLine],
With[{mid=(rList[[1]]+rList[[-1]])/2},ShadedLine[Join[{mid},rList,{mid}],h,ClosedLine->False,opts]],
With[
{unit=L|->L/Norm[L],
perp=L|->{-L[[2]],L[[1]]}},
With[{UnitList=unit/@Differences[rList//N]},
With[{PairedUnitList=Partition[UnitList,2,1]},
With[
{OffsetList=h Join[{perp[UnitList[[1]]]},
({u1,u2}|->- With[{n=Norm[u1+u2]},
If[n==0,Print["Error - Direction change not allowed."],2/n]] With[{p0=-perp[u1],uOff=unit[u2-u1]},If[u1==u2,p0,Sign[p0 . uOff] uOff]])@@@PairedUnitList,{perp[UnitList[[-1]]]}]},
{Join[{GrayLevel[.8]},If[Head[OptionValue[PolygonDirectives]]===List,OptionValue[PolygonDirectives],{OptionValue[PolygonDirectives]}],{Polygon[Join[Reverse[rList],rList+
OffsetList]]}],
Line[rList]}
]]]]]


(* ::Input::Initialization:: *)
PolygonBelowLine[y0_:0,expr_]:=expr/.Line[{pts___}]:>Polygon[{pts,{{pts}[[-1,1]],y0},{{pts}[[1,1]],y0}}]


(* ::Input::Initialization:: *)
CubicSmoothShift[{x1_,y1_,m1_:0},{x2_,y2_,m2_:0},n_:50]:=
With[{x0=x2-x1,y0=y2-y1},
With[{a3=((m1+m2) x0-2 y0)/x0^3,a2=(3 y0-2 m1 x0-m2 x0)/x0^2},
With[{f=Function[x,a3 (x-x1)^3+a2 (x-x1)^2]},
DrawParameterizedCurve[{x,f[x]},{x,x1,x2},n]
]]]


(* ::Input::Initialization:: *)
RoundedBox[{x1_, y1_}, {x2_, y2_},R_,OptionsPattern[]]:=
With[{X=Sort[{x1,x2}],Y=Sort[{y1,y2}]},
Join[{EdgeForm[Join[{
AbsoluteDashing[2.5],Red},OptionValue[LineDirectives]]]},Join[{Opacity[0]},OptionValue[RectangleDirectives]],{Rectangle[{X[[1]],Y[[1]]}-R,{X[[2]],Y[[2]]}+R,RoundingRadius->R]}]]


(* ::Input::Initialization:: *)
PlottingTools::usage="PlottingTools is a simple package (no context created) containing the following functions:   
    LinesFromPlot, LinetoAxis, LinetoBothAxes, LabeledLinetoAxis, SecantLine, TangentLine, PlotAndShade";


(* ::Input::Initialization:: *)
LinesFromPlot::usage="LinesFromPlot uses the Plot function to generate lines. Attributes[]={HoldAll} and \[IndentingNewLine]Attributes[]={HoldAll}  \[IndentingNewLine]LinesFromPlot[exprs__]:=Cases[Plot[exprs],_Line,\[Infinity]]";
LinetoAxis::usage="LinetoAxis[x_,f_]:={Line[{{x,0},{x,f[x]}}]}";
LinetoBothAxes::usage="LinetoBothAxes[x_,f_]:=With[{y=f[x]},{Line[{{x,0},{x,y},{0,y}}]}]";
LabeledLinetoAxis::usage="LabeledLinetoAxis[x_,f_,{txt_,txtOS_}]:=With[{y=f[x]},{Line[{{x,0},{x,y}}],Text[txt,If[NumericQ[txtOS],{x,If[y<0,+1,-1] txtOS},txtOS]]}]  and  \[IndentingNewLine]LabeledLinetoAxis[x_,f_,{txt_,txtOS_},{txt2_,txt2OS_}]:=With[{y=f[x]},{Line[{{x,0},{x,y},{0,y}}],Text[txt,If[NumericQ[txtOS],{x,If[y<0,+1,-1] txtOS},txtOS]],Text[txt2,If[NumericQ[txt2OS],{If[x<0,+1,-1] txt2OS,y},txt2OS]]}]";
SecantLine::usage="SecantLine[{xMin,xMax},f,x1,x2]";
TangentLine::usage="TangentLine[{xMin,xMax_},f,x0]";


(* ::Input::Initialization:: *)
PlotAndShade::usage="PlotAndShade[expr,{x,xMin,xMax},{a,b},opts] creates Plot[expr,{x,xMin,xMax}] and shades between a and b using FillingStyle\[Rule]{Lighter[Red,.6],Lighter[Green,.6]}, which shade positive values red and negative green. opts are for Plot command";


(* ::Input::Initialization:: *)
Attributes[LinesFromPlot]={HoldAll};
LinesFromPlot[exprs__]:=Cases[Plot[exprs],_Line,\[Infinity]]
LinetoAxis[x_,f_]:=With[{y=f[x]},{Line[{{x,0},{x,y}}]}]
LinetoBothAxes[x_,f_]:=With[{y=f[x]},{Line[{{x,0},{x,y},{0,y}}]}]
LabeledLinetoAxis[x_,f_,{txt_,txtOS_}]:=With[{y=f[x]},{Line[{{x,0},{x,y}}],Text[txt,If[NumericQ[txtOS],{x,If[y<0,+1,-1] txtOS},txtOS]]}]
LabeledLinetoAxis[x_,f_,{txt_,txtOS_},{txt2_,txt2OS_}]:=With[{y=f[x]},{Line[{{x,0},{x,y},{0,y}}],Text[txt,If[NumericQ[txtOS],{x,If[y<0,+1,-1] txtOS},txtOS]],Text[txt2,If[NumericQ[txt2OS],{If[x<0,+1,-1] txt2OS,y},txt2OS]]}]
SecantLine[{xMin_,xMax_},f_,x1_,x2_]:=If[x1===x2,{},With[{m=(f[x2]-f[x1])/(x2-x1)},With[{ptFun=x|->{x,f[x1]+m (x-x1)}},Line[{ptFun[xMin],ptFun[xMax]}]]]]
TangentLine[{xMin_,xMax_},f_,x0_]:=With[{m=f'[x0]},With[{ptFun=x|->{x,f[x0]+m (x-x0)}},Line[{ptFun[xMin],ptFun[xMax]}]]]


(* ::Input::Initialization:: *)
Attributes[PlotAndShade]={HoldAll};
PlotAndShade[expr_,{x_,xMin_,xMax_},{a_,b_},opts___]:=
Plot[{expr,Piecewise[{{expr,a<x<b},{0,True}}]},{x,xMin,xMax},FillingStyle->{Lighter[Red,.8],Lighter[Green,.8]},Filling->{2->Axis},PlotStyle->{Automatic,None},opts]


(* ::Input::Initialization:: *)
AnglesAndLabels::usage="AnglesAndLabels is a simple package (no context created) containing the following functions:   
    Polar, Spherical, AngleLabel and PerpendicularLabel";


(* ::Input::Initialization:: *)
Polar::usage="Polar[r,\[Theta]]:= r {Cos[\[Theta]],Sin[\[Theta]]}";
Spherical::usage="Spherical[r,\[Theta],\[Phi]]:= r {Sin[\[Theta]] Cos[\[Phi]],Sin[\[Theta]] Sin[\[Phi]],Cos[\[Theta]]}";
Angle::usage="Angle[x,y]:=ArcCos[\!\(\*FractionBox[\(x . y\), SqrtBox[\(x . x\\\ y . y\)]]\)] and Angle[x]:=Arg[Complex@@x]";
AngleLabel::usage="AngleLabel[base:{0,0},{ang1,ang2},r,rtext,str,opts] or AngleLabel[base:{0,0},{vector1,vector2},r,rtext,str,opts].  The option ArrowSize\[Rule]0 draws no arrow. Negative ArrowSize changes its direction to clockwise.";
PerpendicularLabel::usage="PerpendicularLabel[base:{0,0},\[Theta],a] and PerpendicularLabel[base:{0,0},side1,a]";


(* ::Input::Initialization:: *)
Polar[r_,\[Theta]_]:=r {Cos[\[Theta]],Sin[\[Theta]]}
Spherical[r_,\[Theta]_,\[Phi]_]:=r {Sin[\[Theta]] Cos[\[Phi]],Sin[\[Theta]] Sin[\[Phi]],Cos[\[Theta]]}
Angle[x_List,y_List]:=ArcCos[x . y/Sqrt[x . x y . y]]
Angle[x_List]:=Arg[Complex@@x]


(* ::Input::Initialization:: *)
ArrowSize::usage="ArrowSize is an option for AddArrow, AngleLabel and CoordinateAxes.";


(* ::Input::Initialization:: *)
Options[AngleLabel]={TextOffset->{0,0},ArrowSize->0};


(* ::Input::Initialization:: *)
AngleLabel[base_List:{0,0},{ang1_,ang2_},r_?NumericQ,rtext_,str_,opts:OptionsPattern[]]:=
	AngleLabel[base,{ang1,ang2},{r},rtext,str,opts]
AngleLabel[base_List:{0,0},{side1_List,side2_List},r_,rtext_,str_,opts:OptionsPattern[]]:=
	With[{\[Theta]1=N[Angle[side1]],\[Theta]2=N[Angle[side2]]},AngleLabel[base,{\[Theta]1,If[\[Theta]1<\[Theta]2,\[Theta]2,2 \[Pi]+\[Theta]2]},r,rtext,str,opts]]
AngleLabel[base_List:{0,0},{ang1_?NumericQ,ang2_?NumericQ},r_List,rtext_,str_,OptionsPattern[]]:=
	With[
{TO=OptionValue[TextOffset],R=Mean[r],AW=.5,AS=Abs[OptionValue[ArrowSize]],sgn=Sign[OptionValue[ArrowSize]],\[Theta]=If[OptionValue[ArrowSize]<0,ang1,ang2]},Join[{Circle[base,#,{ang1,ang2}]&/@r},
If[AS==0,{},{Translate[Rotate[{Line[{{R,0}+AS {-AW,-sgn},{R,0},{R,0}+AS {AW,-sgn}}]},\[Theta],{0,0}],base]}],
{Text[str,TO+base+Polar[rtext,(ang1+ang2)/2]]}]]


(* ::Input::Initialization:: *)
PerpendicularLabel[base_List:{0,0},\[Theta]_?NumericQ,a_]:=GeometricTransformation[Line[{{a,0},{a,a},{0,a}}],{RotationMatrix[\[Theta]],base}]
PerpendicularLabel[base_List:{0,0},side1_List,a_]:=PerpendicularLabel[base,N[Arg[Complex@@side1]],a]


(* ::Input::Initialization:: *)
AxesAndTicks::usage="AxesAndTicks is a simple package (no context created) containing the following functions: CoordinateAxes, AxesTicks, Projection3D, CoordinateProjection3D and AddArrow";


(* ::Input::Initialization:: *)
AddArrow::usage="AddArrow[r0,opts] adds an arrow at r0.";
CoordinateAxes::usage="CoordinateAxes[{xL,xR},{yL,yR},opts] makes 2D axes.  CoordinateAxes[{xL,xR},{yL,yR},{zL,zR},opts] makes 3D axes.";
AxesTicks::usage="AxesTicks[xTicks,yTicks,opts]";
Projection3D::usage="Projection3D[expr,opts] uses LinePolygonMap to project coordinates in graphics primitives inside expr as CoordinateProjection3D does coordinates. It using the Option values of CoordinateAxes.";
CoordinateProjection3D::usage="CoordinateProjection3D[{x,y,z},opts] projects 3D to 2D. It using the Option values of CoordinateAxes.";
ArrowSize::usage="ArrowSize is an option for AddArrow, AngleLabel and CoordinateAxes.";


(* ::Input::Initialization:: *)
ArrowSize::usage="ArrowSize is an option for AddArrow, AngleLabel and CoordinateAxes.";
ArrowWidth::usage="ArrowWidth is an option for AddArrow and CoordinateAxes.";
CenterArrow::usage="CenterArrow is an option for AddArrow.";
TickSize::usage="TickSize is an option for CoordinateAxes.";
zAngle::usage="zAngle is an option for CoordinateAxes.";
zScale::usage="zScale is an option for CoordinateAxes.";


(* ::Input::Initialization:: *)
Options[AddArrow]={Direction->0,ArrowSize->1/4,ArrowWidth->1,CenterArrow->False};
Options[AngleLabel]={TextOffset->{0,0},ArrowSize->0};
Options[CoordinateAxes]={ArrowWidth->1,ArrowSize->.2,TickSize->.1,zAngle->55\[Degree],zScale->1/Sqrt[2]};


(* ::Input::Initialization:: *)
CoordinateAxes[{xL_,xR_},opts___Rule]:=
	With[
{a=ArrowSize/.{opts}/.Options[CoordinateAxes],
b=ArrowWidth/.{opts}/.Options[CoordinateAxes]},{Line[{{xL,0},{xR,0}}],Line[{{xR-a,.5 a b},{xR,0},{xR-a,-.5 a b}}]}
	]
CoordinateAxes[{xL_,xR_},{yL_,yR_},opts___Rule]:=
	With[
{a=ArrowSize/.{opts}/.Options[CoordinateAxes],
b=ArrowWidth/.{opts}/.Options[CoordinateAxes]},{Line[{{xL,0},{xR,0}}],Line[{{xR-a,.5 a b},{xR,0},{xR-a,-.5 a b}}],
Line[{{0,yL},{0,yR}}],Line[{{.5 a b,yR-a},{0,yR},{-.5 a b,yR-a}}]}
	]
CoordinateAxes[{xL_,xR_},{yL_,yR_},{zL_,zR_},opts___Rule]:=
	With[
{a=ArrowSize/.{opts}/.Options[CoordinateAxes],
b=ArrowWidth/.{opts}/.Options[CoordinateAxes]},
{Line[{{xL,0,0},{xR,0,0}}],Line[{{xR-a,.5 a b,0},{xR,0,0},{xR-a,-.5 a b,0}}],
Line[{{0,yL,0},{0,yR,0}}],Line[{{.5 a b,yR-a,0},{0,yR,0},{-.5 a b,yR-a,0}}],
Line[{{0,0,zL},{0,0,zR}}],Line[{{.5 a b,0,zR-a},{0,0,zR},{-.5 a b,0,zR-a}}]}
	]


(* ::Input::Initialization:: *)
AxesTicks[xTicks_List,opts___Rule]:=
	With[
		{ts=TickSize/.{opts}/.Options[CoordinateAxes]},{Line[{{#,ts},{#,-ts}}]&/@xTicks}]
AxesTicks[xTicks_List,yTicks_List,opts___Rule]:=
	With[
		{ts=TickSize/.{opts}/.Options[CoordinateAxes]},{Line[{{#,ts},{#,-ts}}]&/@xTicks,Line[{{ts,#},{-ts,#}}]&/@yTicks}]
AxesTicks[xTicks_List,yTicks_List,zTicks_List,opts___Rule]:=
	With[
		{ts=TickSize/.{opts}/.Options[CoordinateAxes]},
{Line[{{#,ts,0},{#,-ts,0}}]&/@xTicks,
Line[{{ts,#,0},{-ts,#,0}}]&/@yTicks,
Line[{{ts,0,#},{-ts,0,#}}]&/@zTicks}]


(* ::Input::Initialization:: *)
Projection3D[expr_,opts___]:=With[
{\[Theta]=zAngle/.{opts}/.Options[CoordinateAxes],
zS=zScale/.{opts}/.Options[CoordinateAxes]},
LinePolygonMap[({
 {1, 0, - zS Sin[\[Theta]]},
 {0, 1, -zS Cos[\[Theta]]}
}) . #&,expr]
]


(* ::Input::Initialization:: *)
CoordinateProjection3D[{x_,y_,z_},opts___]:=
With[
{\[Theta]=zAngle/.{opts}/.Options[CoordinateAxes],
zS=zScale/.{opts}/.Options[CoordinateAxes]},
({
 {1, 0, - zS Sin[\[Theta]]},
 {0, 1, -zS Cos[\[Theta]]}
}) . {x,y,z}
]


(* ::Input::Initialization:: *)
AddArrow[r_List,OptionsPattern[]]:=
	With[
		{\[Theta]=With[{Dir=OptionValue[Direction]},
					Switch[Dir,"Right",0,"Up",90\[Degree],"Left",180\[Degree],"Down",-90\[Degree],_,Dir]],
AS=OptionValue[ArrowSize],
AW=OptionValue[ArrowWidth],s=If[OptionValue[CenterArrow],1/2,0]},
		LinePolygonMap[r+({
 {Cos[\[Theta]], -Sin[\[Theta]]},
 {Sin[\[Theta]], Cos[\[Theta]]}
}) . #&,Line[AS {{s-1/2,AW 1/2},{s+1/2,0},{s-1/2,-AW 1/2}}]]]


(* ::Input::Initialization:: *)
Color::usage="Color is a simple package (no context created) containing the following functions: GrayShade and ColorShade.";


(* ::Input::Initialization:: *)
GrayShade::usage="GrayShade gives the shade of a color. GrayShade[Graylevel[g]]=g";
ColorShade::usage="ColorShade[col,g] changes the shade of a color col to GrayShade g. ColorShade[col,g,s] gives saturation s";


(* ::Input::Initialization:: *)
GrayShade[col_]:=ToColor[col,GrayLevel]//First
ColorShade[col_,g_]/;0<=g<=1:=
With[
{GS=GrayShade[col]},
If[g<GS,Blend[{Black,col},g/GS],Blend[{White,col},(1-g)/(1-GS)]]
]
ColorShade[col_,g_,s_]/;0<=g<=1\[And]0<=s<=1:=Blend[{ColorShade[col,g],GrayLevel[g]},s]


(* ::Input::Initialization:: *)
MinPolynomial::usage="MinPolynomial[{x1,f[x1],f'[x1],f''[x1],...},{x2,f[x2],f'[x2],f''[x2],... },... ] creates an anonymous polynomial function of x of minimal order to match the function value and derivative values at x1, x2, ...";
MinPolynomial::usage="MinPolynomial[{x1,f[x1],f'[x1],f''[x1],...},{x2,f[x2],f'[x2],f''[x2],... },... ] creates an anonymous polynomial function of x of minimal order to match the function value and derivative values at x1, x2, ...";


(* ::Input::Initialization:: *)
MinPolynomial[conditions__List]:=
x|->Evaluate[With[
{ords=-1+Length/@{conditions}},
With[{deg=-1+Plus@@ords,
maxord=Max[ords]},
Module[
{a,poly},
First[(poly=\!\(
\*UnderoverscriptBox[\(\[Sum]\), \(p = 0\), \(deg\)]\(a[p]\ 
\*SuperscriptBox[\(x\), \(p\)]\)\))/.
Solve[((D[poly,{x,#[[-1]]-1}]/.x->#[[1]])==#[[2]])&/@Flatten[With[{alist=Rest[#]},With[{L=Length[alist]},{Table[First[#],{L}],alist,Range[L]}//Transpose]]&/@{conditions},1],Table[a[i],{i,0,deg}]]]
]]]]


(* ::Input::Initialization:: *)
SimpleVectorArray::usage="SimpleVectorArray is an alternative to VectorPlot putting the tails (not centers) of vectors at the points of the array. It creates a list of arrows which can be displayed in Graphics. Arrows can be customized using the ArrowScale option and Arrowheads directive. The points may be plotted with an option and customized with the option PointDirectives.";


(* ::Input::Initialization:: *)
Options[SimpleVectorArray]={PlotPoints->{10,10},ShowPoints->False,PointDirectives->{},ArrowScale->Automatic,ArrowScalingFunction->Identity,ArrowAlignment->"Base"};


(* ::Input::Initialization:: *)
ShowPoints::usage="ShowPoints is an option for SimpleVectorArray.";
PointDirectives::usage="PointDirectives is an option for SimpleVectorArray.";
ArrowScale::usage="ArrowScale is an option for SimpleVectorArray.";
ArrowScalingFunction::usage="ArrowScalingFunction is an option for SimpleVectorArray.";
ArrowAlignment::usage="ArrowAlignment is an option for SimpleVectorArray.";


(* ::Input::Initialization:: *)
Attributes[SimpleVectorArray]={HoldAll};
SimpleVectorArray::arrowAlignmentValue="The option ArrowAlignment value `1` is not \"Base\", \"Centered\" or between 0 and 1.";SimpleVectorArray::plotPoints="The option PlotPoints values, `1`, are not integers greater than one.";SimpleVectorArray[r_,{x_,xMin_,xMax_},{y_,yMin_,yMax_},OptionsPattern[]]/;\[Not]MatrixQ[r]:=With[{funct=({x,y}|->r),xyNum=With[{num=If[Head[OptionValue[PlotPoints]]===List,OptionValue[PlotPoints],OptionValue[PlotPoints] {1,1}]},If[(And@@IntegerQ/@num)\[And]Min[num]>1,num,Message[SimpleVectorArray::plotPoints,num];{2,2}]],
scalingFunction=v|->With[{R=Norm[v],n=Normalize[v],ASF=OptionValue[ArrowScalingFunction]},
Switch[ASF,
Identity,v,
None,n,
_,If[R==0,0,ASF[R] n]]]},
With[{\[CapitalDelta]x=(xMax-xMin)/(xyNum[[1]]-1),\[CapitalDelta]y=(yMax-yMin)/(xyNum[[2]]-1),\[Lambda]=With[{AA=OptionValue[ArrowAlignment]},Which[AA==="Base",0,AA==="Centered",0.5,NumericQ[AA]\[And]0<=AA<=1,AA,True,Message[SimpleVectorArray::arrowAlignmentValue,AA];0]]},With[{pts=Outer[List,Range[xMin,xMax,\[CapitalDelta]x],Range[yMin,yMax,\[CapitalDelta]y]],AS=Switch[OptionValue[ArrowScale],Automatic,Min[\[CapitalDelta]x,\[CapitalDelta]y]/Sqrt[2]//N,_,OptionValue[ArrowScale]]},Flatten[Map[With[{v=AS scalingFunction[funct@@#]},Arrow[{#- \[Lambda] v,#+(1-\[Lambda])v }]]&,pts,{2}]]~Join~
If[OptionValue[ShowPoints],{},With[{PD=OptionValue[PointDirectives]},If[Head[PD]===List,PD,{PD}]]~Join~{Map[Point,pts,{2}]}]]]]


(* ::Input::Initialization:: *)
MakeList::usage="MakeList is a simple function that returns a list: MakeList[x_]:=If[Head[x]===List,x,{x}]";FadeOut::usage="FadeOut[r0,h,th,inset,opts] creates a symbol to truncate an object, indicating it is going to infinity. r0 is the position of the center, h is its height and th is its thickness; inset is the amplitude of the sinusoidal function used. FadeDirection can be \"Right\" (default), \"Left\", \"Up\", \"Down\", \"Top\", \"Bottom\"";


(* ::Input::Initialization:: *)
FadeDirection::usage="FadeDirection is an option for FadeOut.";
BackgroundDirectives::usage="BackgroundDirectives is an option for FadeOut.";
LineNumber::usage="LineNumber is an option for FadeOut.";
DarkColor::usage="DarkColor is an option for FadeOut.";
LightColor::usage="LightColor is an option for FadeOut.";


(* ::Input::Initialization:: *)
MakeList[x_]:=If[Head[x]===List,x,{x}]
Options[FadeOut]={FadeDirection->"Right",BackgroundDirectives->{White},LineNumber->6,PlotPoints->20,DarkColor->Black,LightColor->White};
FadeOut[r0_List,h_,th_,inset_,OptionsPattern[]]:=
With[{curve=Table[{h/2 t,inset Sin[\[Pi] t]},{t,-1,1,2/OptionValue[PlotPoints]}]},
{
Join[MakeList[OptionValue[BackgroundDirectives]],{Polygon[Join[curve,Reverse[curve/.{x_,y_}:>{x,y+th}]]]}],
Table[{Blend[{OptionValue[DarkColor],OptionValue[LightColor]},t],Line[curve/.{x_,y_}:>{x,y+t th}]},{t,0,1,1/(OptionValue[LineNumber]-1)}]
}]/.LinePolygonMappingRules[r|->r0+
RotationMatrix[
Switch[OptionValue[FadeDirection],
"Right",0,
"Left",180\[Degree],
"Up",90\[Degree],
"Top",90\[Degree],
"Down",-90\[Degree],
"Bottom",-90\[Degree],
_,0]] . {r[[2]],-r[[1]]}]
