(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
MechanicsTools::usage="MechanicsTools is a supplement to GraphicsTools containing the following functions: Spring, Pulley, StickMan, SimpleCar, SimpleTruck, GrayBlue, NColor, WColor, TColor, fColor";


(* ::Input::Initialization:: *)
GrayBlue::usage="GrayBlue=RGBColor[.4,.4,.6] is the color used for masses and blocks.";
NColor::usage="NColor=RGBColor[.7,0,0] is the color used for normal forces.";
WColor::usage="WColor=RGBColor[0,0,.7] is the color used for weights.";
TColor::usage="TColor=RGBColor[0,.5,0] is the color used for tensions.";
fColor::usage="fColor=RGBColor[.625,.5,0] is the color used for friction forces.";


(* ::Input::Initialization:: *)
GrayBlue=RGBColor[.4,.4,.6];
NColor=RGBColor[.7,0,0];
WColor=RGBColor[0,0,.7];
TColor=RGBColor[0,.5,0];
fColor=RGBColor[.625,.5,0];


(* ::Input::Initialization:: *)
Spring::usage="Spring[R,num,L] gives a spring or radius R with num turns.  It is of length L from {0,0} to {L,0}.  Spring[{R,f},num,L] is the more general form with f being related to the viewing angle, the radius when viewed from the side is f R, where f has the default value of 0.2. As L gets small (relative to R) choose smaller f.\.10 f=0 is viewed from the side.";


(* ::Input::Initialization:: *)
BackLineDirectives::usage="BackLineDirectives is an option for Spring.";
SwapBackFront::usage="SwapBackFront is an option for Spring.";


(* ::Input::Initialization:: *)
Spring[R_?NumericQ,num_?IntegerQ,L_?NumericQ,opts:OptionsPattern[]]:=Spring[{R,.2},num,L,opts]
Spring[{R_?NumericQ,f_?NumericQ},num_?IntegerQ,L_?NumericQ,OptionsPattern[]]:=
With[{OS=(L Sqrt[2]-2\[Pi] R f)/(num Sqrt[2]+1)},
With[{e=\[Pi]/Sqrt[2] R f+OS/(2 Sqrt[2]),
backDirectives=
If[Head[OptionValue[BackLineDirectives]]===List,OptionValue[BackLineDirectives],{OptionValue[BackLineDirectives]}]},
With[{k=\[Pi]/(2 e),
aDirectives=If[OptionValue[SwapBackFront],backDirectives,{}],
bDirectives=If[OptionValue[SwapBackFront],{},backDirectives]},
{Join[aDirectives,
{DrawParameterizedCurve[{x,R Sin[k x]^2},{x,e},20]},
Table[DrawParameterizedCurve[{R f Sin[\[Theta]]+(i+\[Theta]/(2 \[Pi])) OS+e,R Cos[\[Theta]]},{\[Theta],\[Pi],2 \[Pi]},20],{i,0,num-1}]],
Join[bDirectives,
{DrawParameterizedCurve[{L-x,R Sin[k x]^2},{x,e},20]},
Table[DrawParameterizedCurve[{R f Sin[\[Theta]]+(i+\[Theta]/(2 \[Pi])) OS+e,R Cos[\[Theta]]},{\[Theta],0,\[Pi]},20],{i,0,num-1}]]}
]]]


(* ::Input::Initialization:: *)
Pulley::usage="Pulley[center,base,R,opts] The radius R is the radius on which the string moves; the outside is larger by the options PulleyOversize.  The Option PulleyStyle is Disk by default. PulleyStyle->Spokes[{number,EmptyFraction},{InsideR,OutsideR}], where InsideR and OutsideR are factions of the Pulley radius, and Spokes[] and Spokes[{number,EmptyFraction}] uses SpokeDefaults for values. PulleyStyle->None shows no pulley and BarWidth->0 shows no bar; these can be used to build up complex arrangements";
PulleyOld::usage="PulleyOld[x_List,\[Theta]_,r_,L_,opts___]";


(* ::Input::Initialization:: *)
PulleyStyle::usage="PulleyStyle is an option for Pulley.";
Spokes::usage="Spokes is an option value for the PulleyStyle option of Pulley, PullyStyle->Spokes[___]. Spokes[{num_,emptyFraction_}] and Spokes[{num_,emptyFraction_},{InsideR_,OutsideR_}] are different usages. Spokes[] is a default.";
SpokeDefaults::usage="SpokeDefaults is an option for Pulley.";
BaseFraction::usage="BaseFraction is an option for Pulley.";
RimColor::usage="RimColor is an option for Pulley.";
PulleyColor::usage="PulleyColor is an option for Pulley.";
BarColor::usage="BarColor is an option for Pulley.";
BarWidthScale::usage="BarWidthScale is an option for Pulley.";
BarCenterOversize::usage="BarCenterOversize is an option for Pulley.";
BarBaseOversize::usage="BarBaseOversize is an option for Pulley.";
RotationAngle::usage="RotationAngle is an option for Pulley.";
PulleyOversize::usage="PulleyOversize is an option for Pulley.";
RimLineDirectives::usage="RimLineDirectives is an option for Pulley.";
BarLineDirectives::usage="BarLineDirectives is an option for Pulley.";
InteriorLineDirectives::usage="InteriorLineDirectives is an option for Pulley.";


(* ::Input::Initialization:: *)
PulleyStyle::option="An unknown Option was specified.";
Options[Pulley]={PulleyStyle->Disk,SpokeDefaults->{{10,.4},{.2,.9}},BaseFraction->0.1,RimColor->GrayLevel[.6],PulleyColor->GrayLevel[.7],BarColor->GrayLevel[.6],BarWidthScale->.3,BarCenterOversize->Automatic,BarBaseOversize->0,RotationAngle->0,PulleyOversize->1.05,RimLineDirectives->AbsoluteThickness[1],BarLineDirectives->AbsoluteThickness[1],InteriorLineDirectives->{}};
Options[PulleyOld]={PulleyOversize->1.05,BlackWidth->1};

Options[StickMan]={HeadRadius->1/6,LegHeight->1/3,ArmHeight->1/2,ArmLength->1/4,ArmAngles->{20\[Degree],160\[Degree]},LegWidth->1/8};

Options[RoundedBox]={RectangleDirectives->{},Global`LineDirectives->{}};
Options[Spring]={BackLineDirectives->Opacity[.625],SwapBackFront->False};
Options[SimpleCar]={Reverse->False,Scale->1,TireColor->GrayLevel[.4],CarColor->GrayLevel[.7]};
Options[SimpleTruck]={Reverse->False,Scale->1,TireColor->GrayLevel[.4],TruckColor->GrayLevel[.7],FilledBack->False};


(* ::Input::Initialization:: *)
Pulley[cen_List,base_List,R_?NumericQ,OptionsPattern[]]:=
With[{rimLineDir=If[Head[OptionValue[RimLineDirectives]]===List,OptionValue[RimLineDirectives],{OptionValue[RimLineDirectives]}],barLineDir=If[Head[OptionValue[BarLineDirectives]]===List,OptionValue[BarLineDirectives],{OptionValue[BarLineDirectives]}],intLineDir=If[Head[OptionValue[InteriorLineDirectives]]===List,OptionValue[InteriorLineDirectives],{OptionValue[InteriorLineDirectives]}]},
{Rotate[Switch[OptionValue[PulleyStyle],
None,{},
Disk,Join[{OptionValue[PulleyColor]},{EdgeForm@@rimLineDir},{Disk[cen,R OptionValue[PulleyOversize]]}],
Spokes[___],With[{spokeData=OptionValue[PulleyStyle]/.
(Spokes[]->OptionValue[SpokeDefaults])/.
(Spokes[{num_,emptyFraction_}]:>{{num,emptyFraction},OptionValue[SpokeDefaults][[2]]})/.
(Spokes[{num_,emptyFraction_},{InsideR_,OutsideR_}]:>{{num,emptyFraction},{InsideR,OutsideR}})},
With[{spokeAngularSpacing=(2 \[Pi])/spokeData[[1,1]],
spokeAngularWidth=(2 \[Pi])/spokeData[[1,1]] spokeData[[1,2]],
num=spokeData[[1,1]],insideR=spokeData[[2,1]],outsideR=spokeData[[2,2]]},
{{OptionValue[PulleyColor],{Join[{EdgeForm@@intLineDir},Table[Disk[cen,R,spokeAngularWidth/2 {-1,1}+i spokeAngularSpacing],{i,1,num}]],
{EdgeForm@@intLineDir,Disk[cen,R insideR]},Annulus[cen,{R outsideR,R OptionValue[PulleyOversize]}]}},Join[intLineDir,{Circle[cen,R outsideR]}],
Join[rimLineDir,{Circle[cen,R OptionValue[PulleyOversize]]}]
}]],
_,Message[PulleyStyle::option];{}
],OptionValue[RotationAngle],cen],
If[OptionValue[BarWidthScale]===0,{},
With[{u=Normalize[base-cen],L=Norm[base-cen],W=R*OptionValue[BarWidthScale]},
With[{v={-u[[2]],u[[1]]},
cenOverSize=If[OptionValue[BarCenterOversize]===Automatic,W/2,R*OptionValue[BarCenterOversize]],
baseOverSize=R*OptionValue[BarBaseOversize]},
{OptionValue[BarColor],EdgeForm@@barLineDir,GeometricTransformation[Rectangle[{-cenOverSize,-W/2},{L+baseOverSize,W/2}],{Transpose[{u,v}],cen}]}]]
]
}]


(* ::Input::Initialization:: *)
PulleyOld[x_List,\[Theta]_,r_,L_,opts___]:=
	With[
		{OS=PulleyOversize/.{opts}/.Options[PulleyOld],BW=BlackWidth/.{opts}/.Options[PulleyOld]},LinePolygonMap[{{Cos[\[Theta]],-Sin[\[Theta]]},{Sin[\[Theta]],Cos[\[Theta]]}} . #+x&,
		With[
		{R=r OS,\[Rho]=.1 r OS},
		{AbsoluteThickness[BW],
			{GrayLevel[.7],Disk[x,R]},Circle[x,R],
			{GrayLevel[.8],Polygon[{{R/5,-2 \[Rho]},{R/5,L},{-(R/5),L},{-(R/5),-2 \[Rho]}}]},Line[{{R/5,-2 \[Rho]},{R/5,L},{-(R/5),L},{-(R/5),-2 \[Rho]},{R/5,-2 \[Rho]}}]
		}
	]]]


(* ::Input::Initialization:: *)
StickMan::usage="StickMan[base,h,opts]";


(* ::Input::Initialization:: *)
HeadRadius::usage="HeadRadius is an option for StickMan.";
LegHeight::usage="LegHeight is an option for StickMan.";
ArmHeight::usage="ArmHeight is an option for StickMan.";
ArmLength::usage="ArmLength is an option for StickMan.";
ArmAngles::usage="ArmAngles is an option for StickMan.";
LegWidth::usage="LegWidth is an option for StickMan.";


(* ::Input::Initialization:: *)
StickMan[base_List,h_,opts___]:=
	Translate[
		With[
		{v={0,h},
			r=HeadRadius/.{opts}/.Options[StickMan],
			LH=LegHeight/.{opts}/.Options[StickMan],
			AH=ArmHeight/.{opts}/.Options[StickMan],
			AL=ArmLength/.{opts}/.Options[StickMan],
			AAs=ArmAngles/.{opts}/.Options[StickMan],
			LW=LegWidth/.{opts}/.Options[StickMan]},
		{Circle[(1-r) v,r h],
			Line[{LH v,(1-2 r) v}],
			Line[{AH v+h Polar[AL,AAs[[1]]],AH v,AH v+ h Polar[AL,AAs[[2]]]}],
		Line[{{-h LW,0},{0,h LH},{h LW,0}}]}],base]


(* ::Input::Initialization:: *)
SimpleCar::usage="SimpleCar[r:{0,0},opts] makes a car with r below the center at road level. The car has width 1\[Times]Scale, where Scale is an option with default value 1.";
SimpleTruck::usage="SimpleTruck[r:{0,0},opts] makes a truck with r below the center of the open back at road level. Scale is an option with default value 1. The open back interior as width 1\[Times]Scale with floor and ceiling at y=0.1\[Times]Scale and y=.8\[Times]Scale. The cab has an additional width 0.75\[Times]Scale.";


(* ::Input::Initialization:: *)
TireColor::usage="TireColor is an option for SimpleCar.";
CarColor::usage="CarColor is an option for SimpleCar.";
TireColor::usage="TireColor is an option for SimpleTruck.";
TruckColor::usage="TruckColor is an option for SimpleTruck.";
FilledBack::usage="FilledBack is an option for SimpleTruck.";


(* ::Input::Initialization:: *)
SimpleCar[r_List:{0,0},OptionsPattern[]]:=With[{sgn=If[OptionValue[Reverse],-1,1],scale=OptionValue[Scale],h=.06,a1=.44,b1=.4,\[Theta]=72\[Degree],a2=.31,b2=.25,Rw=.08,w1=-.35,w2=.35},With[{x1=a1-.5,x2=.5-a2},{{OptionValue[CarColor],Disk[r+scale {sgn x1,h},scale {a1,b1},If[sgn==-1,{0,\[Pi]-\[Theta]},{\[Theta],\[Pi]}]],Disk[r+scale {sgn x2,h},scale {a2,b2},If[sgn==-1,{\[Pi]/2,\[Pi]},{0,\[Pi]/2}]],Polygon[{r+scale {sgn (x1-a1),h},r+scale {sgn (x2+a2),h},r+scale {sgn x2,h+b2},r+scale {sgn (x1+a1 Cos[\[Theta]]),h+b1 Sin[\[Theta]]}}]},{OptionValue[TireColor],Disk[r+scale {sgn w1,Rw},scale Rw],Disk[r+scale {sgn w2,Rw},scale Rw]}}]]
SimpleTruck[r_List:{0,0},OptionsPattern[]]:=With[{sgn=If[OptionValue[Reverse],-1,1],scale=OptionValue[Scale],h=.1,th=.03,H=.7,WR=.08,W1=-.35,W2=1.1,w1Cab=.35,h1Cab=.6,RR1=.05,\[Theta]1=60\[Degree],w2Cab=.75,h2Cab=.3,RR2=.1,\[Theta]2=80\[Degree],n=10},
{
{OptionValue[TruckColor],Polygon[Join[{r+scale{sgn (.5+th/2),h-th},r+scale{sgn (.5+th/2),h+h1Cab}},Table[r+scale{sgn (.5+w1Cab-RR1+RR1 Sin[\[Theta]]),h+h1Cab-RR1+RR1 Cos[\[Theta]]},{\[Theta],0,\[Theta]1,\[Theta]1/n}],{r+scale{sgn (.5+w1Cab-RR1+RR1 Sin[\[Theta]1]),h+h1Cab-RR1+RR1 Cos[\[Theta]1]}+scale(w2Cab-w1Cab){sgn Cos[\[Theta]1],-Sin[\[Theta]1]}}]],
Polygon[Join[{r+scale{sgn (.5+th/2),h-th},r+scale{sgn (.5+w2Cab),h-th}},Table[r+scale{sgn (.5+w2Cab-RR2+RR2 Cos[\[Theta]]),h+h2Cab-RR2+RR2 Sin[\[Theta]]},{\[Theta],0,\[Theta]2,\[Theta]2/n}],{r+scale{sgn (.5+w2Cab-RR2+RR2 Cos[\[Theta]2]),h+h2Cab-RR2+RR2 Sin[\[Theta]2]}+scale(w2Cab-w1Cab){-sgn Sin[\[Theta]2],Cos[\[Theta]2]}}]],
If[OptionValue[FilledBack],
{OptionValue[TruckColor],Rectangle[r+scale{.5 sgn ,h+H}+sgn scale th {1,1},r+scale{-.5 sgn ,h}-sgn scale th {1,1}]},
{OptionValue[TireColor],AbsoluteThickness[2],ShadedLine[{r+scale{-.5 sgn ,h+H},r+scale{.5 sgn ,h+H},r+scale{.5 sgn ,h},r+scale{-.5 sgn ,h}},sgn scale th,ClosedLine->True,PolygonDirectives->OptionValue[TruckColor]]}],
{OptionValue[TireColor],
Disk[r+scale{sgn W1,WR},scale WR],Disk[r+scale{sgn W2,WR},scale WR]}}
}]
